(define_conditions [
  (-1 "RS6000_RECIP_AUTO_RE_P (SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math")
  (-1 "(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && ( reload_completed)")
  (-1 "TARGET_P9_VECTOR && reload_completed")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW
   && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "TARGET_POWERPC64 && TARGET_DIRECT_MOVE
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])")
  (-1 "TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode")
  (-1 "TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)")
  (-1 "VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN")
  (-1 "(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && (TARGET_64BIT)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V8HImode)
       || int_reg_operand (operands[1], V8HImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V8HImode)
           && !vsx_register_operand (operands[1], V8HImode)))")
  (-1 "(TARGET_LONG_DOUBLE_128 && TARGET_VSX && FLOAT128_IBM_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && (TARGET_POWERPC64)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "TARGET_HARD_FLOAT && TARGET_PPC_GPOPT")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()")
  (-1 "VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR")
  (-1 "TARGET_P9_MISC && TARGET_64BIT")
  (-1 "(TARGET_HARD_FLOAT
   && (!FLOAT128_IEEE_P (KFmode)
       || (TARGET_POWERPC64 && TARGET_DIRECT_MOVE))) && (TARGET_FLOAT128_TYPE)")
  (-1 "(TARGET_HTM) && (TARGET_POWERPC64)")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && ((((TARGET_64BIT) && (TARGET_P8_VECTOR)) && (TARGET_P8_VECTOR)) && (TARGET_P8_VECTOR))")
  (-1 "(TARGET_ALTIVEC) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(rs6000_speculate_indirect_jumps && !rs6000_relative_jumptables) && (TARGET_64BIT)")
  (-1 "TARGET_FCFID && TARGET_HARD_FLOAT
   && (TARGET_FCFIDS || TARGET_POWERPC64 || flag_unsafe_math_optimizations)")
  (-1 "TARGET_64BIT")
  (-1 "TARGET_HARD_FLOAT && TARGET_VSX && TARGET_FPRND")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))")
  (-1 "TARGET_32BIT")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "((VECTOR_MEM_VSX_P (V4SFmode)) && (TARGET_32BIT)) && ( reload_completed)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR")
  (0 "(TARGET_MACHO && (DEFAULT_ABI == ABI_DARWIN) && !flag_pic) && (TARGET_32BIT)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed")
  (-1 "TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD")
  (-1 "(TARGET_PCREL_OPT) && (TARGET_POWERPC64)")
  (-1 "(!HONOR_SIGNED_ZEROS (V4SFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode))")
  (-1 "TARGET_P9_VECTOR && TARGET_DIRECT_MOVE && TARGET_POWERPC64")
  (-1 "VECTOR_UNIT_P8_VECTOR_P (V2DImode)")
  (-1 "(SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR")
  (-1 "TARGET_DFP")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_P8_VECTOR")
  (-1 "TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)")
  (-1 "VECTOR_MEM_VSX_P (TFmode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && (((TARGET_32BIT) && (TARGET_POWERPC64)) && (TARGET_POWERPC64))")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed")
  (-1 "(DEFAULT_ABI == ABI_ELFv2) && (TARGET_64BIT)")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()")
  (-1 "gpc_reg_operand (operands[0], HImode)
   || gpc_reg_operand (operands[1], HImode)")
  (-1 "(SImode == Pmode) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "TARGET_MMA")
  (-1 "TARGET_HARD_FLOAT
   && ((TARGET_FCFIDS && TARGET_LFIWAX)
       || (TARGET_FCFID
	   && (TARGET_POWERPC64 || flag_unsafe_math_optimizations)))")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && (TARGET_64BIT)")
  (-1 "logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)")
  (-1 "((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_32BIT)")
  (-1 "((TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))) && ( 1)")
  (-1 "TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)")
  (-1 "((!TARGET_POWER10) && (TARGET_64BIT)) && ( 1)")
  (-1 "((TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (FLOAT128_2REG_P (TFmode))) && ( reload_completed)")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN")
  (-1 "((TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))) && ( 1)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(V16QImode == TImode || V16QImode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "(TARGET_ALTIVEC) && (TARGET_32BIT)")
  (-1 "DEFAULT_ABI == ABI_V4
    && flag_pic == 1
    && reload_completed")
  (-1 "((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && (TARGET_64BIT)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_PCREL_OPT) && (TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && ( can_create_pseudo_p ())")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(!HONOR_SIGNED_ZEROS (KFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode))")
  (-1 "TARGET_VSX && reload_completed")
  (-1 "TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT")
  (-1 "((TARGET_P10_FUSION)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && ( reload_completed)")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "(TARGET_LONG_DOUBLE_128 && TARGET_VSX && FLOAT128_IBM_P (TFmode)) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && (TARGET_LONG_DOUBLE_128)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))")
  (-1 "(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && (TARGET_64BIT)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "VECTOR_UNIT_ALTIVEC_P (V4SFmode)")
  (-1 "TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])")
  (-1 "((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && (TARGET_64BIT)")
  (-1 "((DImode == Pmode) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))")
  (-1 "(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (TARGET_LONG_DOUBLE_128)")
  (-1 "TARGET_MFCRF")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_NONE_P (TImode)
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode)))")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))")
  (-1 "((VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (TARGET_FLOAT128_HW)) && ( 1)")
  (-1 "!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)")
  (-1 "(!TARGET_ISEL) && (TARGET_POWERPC64)")
  (-1 "(((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))")
  (-1 "(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && ( reload_completed)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && ( 1)")
  (-1 "TARGET_POPCNTD")
  (-1 "(TARGET_ALTIVEC) && (((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_POWERPC64 && TARGET_DIRECT_MOVE")
  (-1 "TARGET_ALTIVEC || TARGET_VSX")
  (-1 "VECTOR_MEM_VSX_P (V2DImode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V16QImode)) && (TARGET_ALTIVEC)")
  (-1 "TARGET_MINMAX")
  (-1 "(((TARGET_P10_FUSION)) && (TARGET_POWERPC64)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_DS)))")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFIDS")
  (-1 "(((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "((INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_32BIT)")
  (-1 "(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)")
  (-1 "TARGET_POWERPC64")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && (TARGET_ALTIVEC)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX) && ( 1)")
  (0 "TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)
   && VECTOR_UNIT_ALTIVEC_P (V4SImode)")
  (-1 "TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(FLOAT128_IEEE_P (TFmode)
   || (FLOAT128_IBM_P (TFmode) && TARGET_HARD_FLOAT)) && (TARGET_LONG_DOUBLE_128)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V8HImode)) && (TARGET_ALTIVEC)")
  (-1 "(DEFAULT_ABI == ABI_AIX) && (TARGET_32BIT)")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode)) && (TARGET_POWER10)")
  (-1 "TARGET_XSCVSPDPN")
  (-1 "VECTOR_MEM_ALTIVEC_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))")
  (-1 "TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_MADDLD) && (TARGET_POWERPC64)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V4SFmode)) && (TARGET_ALTIVEC)")
  (-1 "((TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (FLOAT128_2REG_P (TFmode))) && ( reload_completed)")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR")
  (-1 "VECTOR_MEM_VSX_P (V16QImode)")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)")
  (-1 "(gpc_reg_operand (operands[0], SFmode)
   || gpc_reg_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT")
  (-1 "!TARGET_P8_VECTOR")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_32BIT)")
  (-1 "(rs6000_speculate_indirect_jumps && rs6000_relative_jumptables) && (TARGET_32BIT)")
  (-1 "TARGET_CMPB && TARGET_POPCNTB")
  (-1 "((HAVE_AS_TLS && TARGET_ELF) && (TARGET_32BIT)) && ( TARGET_CMODEL != CMODEL_SMALL)")
  (0 "TARGET_MACHO && TARGET_HARD_FLOAT && !TARGET_64BIT")
  (-1 "((VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)) && ( reload_completed)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && ( 1)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR")
  (-1 "((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && (TARGET_32BIT)")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && (TARGET_32BIT)")
  (-1 "(!HONOR_SIGNED_ZEROS (DFmode) && !VECTOR_UNIT_ALTIVEC_P (DFmode)) && (TARGET_HARD_FLOAT || VECTOR_UNIT_VSX_P (DFmode))")
  (-1 "(TARGET_P9_VECTOR) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()")
  (-1 "(TARGET_POWERPC64 && INTVAL (operands[2]) == 16) && ( 1)")
  (-1 "(reload_completed
   && (int_reg_operand (operands[0], TFmode)
       || int_reg_operand (operands[1], TFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TFmode)
           && !vsx_register_operand (operands[1], TFmode)))) && (FLOAT128_VECTOR_P (TFmode))")
  (1 "PTImode == TImode || PTImode == PTImode || TARGET_P8_VECTOR")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (TFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode))")
  (-1 "rs6000_is_valid_and_mask (operands[2], SImode)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_VSX_P (V8HImode)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(DEFAULT_ABI == ABI_DARWIN) && (TARGET_32BIT)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && (TARGET_ALTIVEC)")
  (-1 "(!rs6000_speculate_indirect_jumps && rs6000_relative_jumptables) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed")
  (-1 "(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(register_operand (operands[0], SDmode)
   || register_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT")
  (-1 "(TARGET_EXTSWSLI) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))")
  (-1 "(((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (IFmode)) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "(TARGET_XL_COMPAT && FLOAT128_IBM_P (TFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_POWER10) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(TARGET_POWERPC64 && INTVAL (operands[2]) == 32) && ( 1)")
  (-1 "(!TARGET_POWER10) && (TARGET_64BIT)")
  (-1 "reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], HImode)")
  (-1 "(TARGET_XL_COMPAT && FLOAT128_IBM_P (TFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && ((FLOAT128_IBM_P (TFmode)) && (TARGET_POWERPC64))")
  (-1 "TARGET_CTZ")
  (-1 "TARGET_POWERPC64 && TARGET_HARD_FLOAT && !TARGET_FCFIDS")
  (-1 "(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "((DImode == Pmode) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (KFmode))) && ( 1)")
  (-1 "(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && ( reload_completed)")
  (-1 "TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()")
  (-1 "VECTOR_MEM_VSX_P (V2DImode) && !reload_completed")
  (-1 "TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))")
  (-1 "TARGET_PPC_GFXOPT")
  (-1 "(TARGET_CMPB) && (TARGET_POWERPC64)")
  (-1 "(WORDS_BIG_ENDIAN && !(DImode == SImode && TARGET_POWERPC64)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR")
  (-1 "(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && (TARGET_POWERPC64)")
  (-1 "TARGET_POPCNTB")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && ((((TARGET_32BIT) && (TARGET_POWERPC64)) && (TARGET_POWERPC64)) && (TARGET_POWERPC64))")
  (-1 "(TARGET_ALTIVEC) && (TARGET_64BIT)")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))")
  (-1 "TARGET_HARD_FLOAT && TARGET_VSX")
  (-1 "!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))")
  (-1 "TARGET_P9_MINMAX")
  (-1 "(!HONOR_SIGNED_ZEROS (SFmode)) && (TARGET_HARD_FLOAT)")
  (0 "(FLOAT128_2REG_P (TDmode) && TARGET_SOFT_FLOAT) && (TARGET_HARD_FLOAT)")
  (-1 "(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && ( 1)")
  (-1 "(SImode == Pmode) && ( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))")
  (-1 "(!HONOR_SIGNED_ZEROS (TFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode))")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "INTVAL (operands[2]) == 8")
  (-1 "(rs6000_speculate_indirect_jumps && rs6000_relative_jumptables) && (TARGET_64BIT)")
  (-1 "(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && ((((((TARGET_POWERPC64) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])")
  (-1 "(gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_SOFT_FLOAT")
  (-1 "reload_completed && !TARGET_P8_VECTOR")
  (-1 "(TARGET_ALTIVEC) && ((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (FLOAT128_VECTOR_P (KFmode)))")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && (TARGET_ALTIVEC)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_P8_FUSION) && (TARGET_POWERPC64)")
  (-1 "(TARGET_POWERPC64 && INTVAL (operands[2]) == 8) && ( 1)")
  (-1 "nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode)")
  (-1 "WORDS_BIG_ENDIAN && !(SImode == SImode && TARGET_POWERPC64)")
  (-1 "(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && (TARGET_POWERPC64)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS) && ( 1)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)")
  (-1 "reload_completed && int_reg_operand (operands[0], TImode)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "RS6000_RECIP_AUTO_RE_P (V2DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (TFmode))) && ( 1)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(TARGET_ALTIVEC) && ((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (FLOAT128_VECTOR_P (TFmode)))")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(rs6000_speculate_indirect_jumps && !rs6000_relative_jumptables) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)")
  (-1 "(QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()")
  (-1 "((VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (TFmode))) && ( 1)")
  (-1 "(((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (TDmode)) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], TImode)
       || int_reg_operand (operands[1], TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TImode)
           && !vsx_register_operand (operands[1], TImode)))")
  (-1 "(TARGET_P9_VECTOR) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR")
  (-1 "!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)")
  (-1 "(V1TImode == TImode || V1TImode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "(TARGET_ALTIVEC) && (((FLOAT128_VECTOR_P (KFmode)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "((VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && ( reload_completed)")
  (-1 "TARGET_MULTIPLE")
  (-1 "((!TARGET_POWER10) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "((!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_32BIT)) && ( 1)")
  (-1 "direct_return ()")
  (-1 "(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !(TARGET_P8_VECTOR && TARGET_DIRECT_MOVE)) && ( 1)")
  (-1 "VECTOR_MEM_VSX_P (KFmode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "(VECTOR_UNIT_VSX_P (V4SFmode)) && ( 1)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCTIDUZ")
  (-1 "((TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))) && ( 1)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR")
  (-1 "(TARGET_CTZ) && (TARGET_POWERPC64)")
  (-1 "(TARGET_P9_VECTOR) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (DFmode)) && (TARGET_HARD_FLOAT || VECTOR_UNIT_VSX_P (DFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))")
  (-1 "TARGET_DFP && TARGET_POPCNTD")
  (-1 "(((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && ( reload_completed)")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && (TARGET_64BIT)")
  (-1 "(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && (TARGET_32BIT)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V2DImode)
       || int_reg_operand (operands[1], V2DImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DImode)
           && !vsx_register_operand (operands[1], V2DImode)))")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && (TARGET_ALTIVEC)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()")
  (-1 "((TARGET_P10_FUSION)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))")
  (-1 "VECTOR_MEM_ALTIVEC_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))")
  (-1 "!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4
   && (flag_pic == 2 || (flag_pic && TARGET_SECURE_PLT))")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCTIWUZ")
  (-1 "can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)")
  (0 "TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4
   && (flag_pic == 2 || (flag_pic && TARGET_SECURE_PLT))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (KFmode))) && ( reload_completed)")
  (-1 "register_operand (operands[0], CCmode)
   || register_operand (operands[1], CCmode)")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode)")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode)")
  (-1 "!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)")
  (-1 "TARGET_ELF && DEFAULT_ABI == ABI_V4
   && (flag_pic == 2 || (flag_pic && TARGET_SECURE_PLT))")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && (TARGET_32BIT)")
  (-1 "(TARGET_HARD_FLOAT && FLOAT128_IBM_P (TFmode)) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))) && ( reload_completed
   && (!MEM_P (operands[0]) && !MEM_P (operands[1])))")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && (TARGET_32BIT)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))")
  (-1 "DEFAULT_ABI == ABI_V4 && flag_pic == 1")
  (-1 "(!rs6000_speculate_indirect_jumps && !rs6000_relative_jumptables) && (TARGET_64BIT)")
  (-1 "TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (DFmode))")
  (-1 "TARGET_CRYPTO")
  (-1 "TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)")
  (-1 "!TARGET_FCFID && TARGET_HARD_FLOAT")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && (TARGET_64BIT)")
  (-1 "(TARGET_XL_COMPAT && FLOAT128_IBM_P (IFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(reload_completed && int_reg_operand (operands[0], V2DFmode)) && (TARGET_ALTIVEC)")
  (-1 "((FLOAT128_IBM_P (IFmode) && !TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))")
  (-1 "(register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode))
   && TARGET_HARD_FLOAT
   && (TARGET_ALLOW_SF_SUBREG
       || valid_sf_si_move (operands[0], operands[1], SFmode))")
  (-1 "reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))")
  (-1 "((!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCFIDUS) && ( reload_completed)")
  (-1 "(!HONOR_SIGNED_ZEROS (TFmode) && !VECTOR_UNIT_ALTIVEC_P (TFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode))")
  (-1 "RS6000_RECIP_AUTO_RE_P (V4SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math")
  (-1 "(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_2REG_P (IFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && (TARGET_32BIT)")
  (-1 "(!rs6000_speculate_indirect_jumps && !rs6000_relative_jumptables) && (TARGET_32BIT)")
  (-1 "(rs6000_speculate_indirect_jumps) && (TARGET_64BIT)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)")
  (-1 "TARGET_DIRECT_MOVE")
  (-1 "(TARGET_ALTIVEC) && (TARGET_POWERPC64)")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "((SImode == Pmode) && (TARGET_32BIT)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 " reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (TDmode)) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW
   && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))) && ( 1)")
  (-1 "TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic")
  (-1 "(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && (TARGET_32BIT)")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN")
  (-1 "((!flag_finite_math_only) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_EXTSWSLI) && ( reload_completed && MEM_P (operands[1]))")
  (-1 "(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && (TARGET_POWERPC64)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (KFmode))) && ( reload_completed && int_reg_operand (operands[1], KFmode))")
  (-1 "((TARGET_XL_COMPAT && FLOAT128_IBM_P (IFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed")
  (-1 "! TARGET_POWERPC64
   && (PTImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode))")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (TFmode))) && ( reload_completed && int_reg_operand (operands[1], TFmode))")
  (-1 "BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)")
  (-1 "((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (0 "TARGET_MACHO && TARGET_HARD_FLOAT && TARGET_64BIT")
  (-1 "TARGET_POWERPC64 && INTVAL (operands[2]) == 8")
  (-1 "TARGET_POWER10")
  (-1 "TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2")
  (-1 "TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))")
  (-1 "((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) == (BYTES_BIG_ENDIAN ? 1 : 2))")
  (-1 "(TARGET_POWER10) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(FLOAT128_IBM_P (IFmode) && !TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (TFmode)) && (TARGET_LONG_DOUBLE_128)) && ( reload_completed)")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB")
  (-1 "(TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "VECTOR_MEM_VSX_P (V2DImode)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode)")
  (-1 "((TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_2REG_P (IFmode))) && ( reload_completed)")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)")
  (-1 "VECTOR_MEM_VSX_P (V2DImode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)")
  (-1 "! TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))")
  (-1 "(TARGET_P9_VECTOR) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(TARGET_P10_FUSION)")
  (-1 "TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()")
  (-1 "(!HONOR_SIGNED_ZEROS (V4SFmode) && !VECTOR_UNIT_ALTIVEC_P (V4SFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode))")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode) && TARGET_ALTIVEC")
  (-1 "(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "(TARGET_MMA
   && vsx_register_operand (operands[1], OOmode)) && ( reload_completed)")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && (TARGET_ALTIVEC)")
  (0 "TARGET_MACHO && (DEFAULT_ABI == ABI_DARWIN) && TARGET_32BIT")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))) && ( 1)")
  (-1 "TARGET_P9_VECTOR")
  (1 "FLOAT128_IEEE_P (KFmode)")
  (-1 "TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && (TARGET_32BIT)")
  (-1 "RS6000_RECIP_HAVE_RE_P (DFmode)")
  (-1 "((HAVE_AS_TLS) && (TARGET_64BIT)) && ( TARGET_CMODEL != CMODEL_SMALL)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(TARGET_HARD_FLOAT
   && !(TARGET_P8_VECTOR && TARGET_DIRECT_MOVE)) && ( 1)")
  (-1 "TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed")
  (-1 "((!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128 && FLOAT128_IBM_P (IFmode)) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "((VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && ( reload_completed)")
  (0 "(TARGET_MACHO && (DEFAULT_ABI == ABI_DARWIN) && !flag_pic) && (TARGET_64BIT)")
  (0 "TARGET_MACHO && TARGET_HARD_FLOAT && ! TARGET_64BIT")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_P8_VECTOR) && ( 1)")
  (-1 "(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])
   && quad_int_reg_operand (operands[0], PTImode)")
  (-1 "(SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (IFmode)) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "(TARGET_MMA) && ( reload_completed)")
  (-1 "(!TARGET_POWER10) && (TARGET_32BIT)")
  (-1 "reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && ( 1)")
  (-1 "(TARGET_POWER10 && TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_ALTIVEC && reload_completed) && (TARGET_64BIT)")
  (-1 "(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && (((TARGET_64BIT) && (TARGET_POWERPC64)) && (TARGET_POWERPC64))")
  (-1 "TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)")
  (0 "TARGET_XCOFF && HAVE_AS_TLS")
  (-1 "(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "! TARGET_POWERPC64
   && (TImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode))")
  (-1 "(SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)")
  (-1 "TARGET_P8_VECTOR")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (TFmode))")
  (1 "TImode == TImode || TImode == PTImode || TARGET_P8_VECTOR")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID")
  (-1 "RS6000_RECIP_AUTO_RE_P (DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT && !TARGET_P9_VECTOR) && ( reload_completed)")
  (0 "TARGET_MACHO && flag_pic")
  (-1 "(rs6000_speculate_indirect_jumps) && (TARGET_32BIT)")
  (-1 "TARGET_POWERPC64 && INTVAL (operands[2]) == 16")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))")
  (-1 "VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN")
  (-1 "!TARGET_64BIT")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], SImode))) && (TARGET_32BIT)")
  (-1 "(TARGET_ALTIVEC) && ((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (FLOAT128_VECTOR_P (TFmode)))")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "(TARGET_ALTIVEC) && ((((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (FLOAT128_VECTOR_P (KFmode)))")
  (-1 "(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && ( 1)")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW
   && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))) && ( 1)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode)")
  (-1 "(TARGET_ALTIVEC) && ((((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (FLOAT128_VECTOR_P (TFmode)))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)")
  (-1 "TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR")
  (-1 "(HAVE_AS_TLS) && (TARGET_64BIT)")
  (-1 "(V2DImode == TImode || V2DImode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && ( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR")
  (-1 "(TARGET_MMA
   && fpr_reg_operand (operands[1], XOmode)) && ( reload_completed)")
  (-1 "(VECTOR_MEM_ALTIVEC_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)")
  (-1 "TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (PTImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))")
  (-1 "(TARGET_POWER10) && (TARGET_POWERPC64)")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && (TARGET_ALTIVEC)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_POWERPC64 && TARGET_DIRECT_MOVE")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWZX")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && (TARGET_ALTIVEC)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()")
  (-1 "((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "RS6000_RECIP_HAVE_RSQRTE_P (V4SFmode)")
  (-1 "((!TARGET_POWER10) && (TARGET_32BIT)) && ( 1)")
  (-1 "(((TARGET_P10_FUSION)) && (TARGET_POWERPC64)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))")
  (166 "UNSPEC_XST_LEN_R")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(!TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && ( can_create_pseudo_p ())")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS")
  (-1 "register_operand (operands[0], CCFPmode)
   || register_operand (operands[1], CCFPmode)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))")
  (-1 "!(SImode == SImode && TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR")
  (-1 "(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)) && ( reload_completed)")
  (-1 "((TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))) && ( reload_completed)")
  (-1 "(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)) && ( 1)")
  (-1 "TARGET_FCFID && TARGET_HARD_FLOAT")
  (-1 "TARGET_POWERPC64 && num_insns_constant (operands[1], DImode) > 1")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)")
  (-1 "(!rs6000_speculate_indirect_jumps) && (TARGET_32BIT)")
  (-1 "(TARGET_ELF && HAVE_AS_TLS) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && (TARGET_64BIT)) && ( TARGET_CMODEL != CMODEL_SMALL && reload_completed)")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)")
  (-1 "(reload_completed) && (TARGET_64BIT)")
  (-1 "TARGET_HARD_FLOAT
   && !(TARGET_P8_VECTOR && TARGET_DIRECT_MOVE)")
  (-1 "(FLOAT128_IEEE_P (IFmode)
   || (FLOAT128_IBM_P (IFmode) && TARGET_HARD_FLOAT)) && (TARGET_FLOAT128_TYPE)")
  (-1 "(DImode == Pmode) && (TARGET_POWERPC64)")
  (-1 "(TARGET_HARD_FLOAT
   && (!FLOAT128_IEEE_P (IFmode)
       || (TARGET_POWERPC64 && TARGET_DIRECT_MOVE))) && (TARGET_FLOAT128_TYPE)")
  (-1 "rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0")
  (-1 "TARGET_MADDLD && BYTES_BIG_ENDIAN && TARGET_POWERPC64")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_MODULO) && (TARGET_POWERPC64)")
  (-1 "(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))")
  (-1 "((TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && (TARGET_32BIT)) && ( TARGET_CMODEL != CMODEL_SMALL && reload_completed)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)")
  (-1 "(!rs6000_speculate_indirect_jumps && rs6000_relative_jumptables) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_P (V4SImode)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (FLOAT128_2REG_P (TFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "(rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)")
  (-1 "SImode == Pmode")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V16QImode)
       || int_reg_operand (operands[1], V16QImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V16QImode)
           && !vsx_register_operand (operands[1], V16QImode)))")
  (-1 "VECTOR_MEM_VSX_P (V1TImode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "(reload_completed) && (TARGET_32BIT)")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "(((TARGET_P10_FUSION)) && (TARGET_POWERPC64)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))")
  (-1 "((VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (FLOAT128_2REG_P (IFmode))) && ( 1)")
  (-1 "((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)")
  (-1 "num_insns_constant (operands[1], SImode) > 1")
  (-1 "TARGET_POWERPC64 && TARGET_LDBRX")
  (-1 "(TARGET_POPCNTD) && (TARGET_32BIT)")
  (-1 "register_operand (operands[0], CCEQmode)
   || register_operand (operands[1], CCEQmode)")
  (-1 "TARGET_MADDLD && !BYTES_BIG_ENDIAN && TARGET_POWERPC64")
  (-1 "(!TARGET_FCFID && TARGET_HARD_FLOAT) && ( 1)")
  (-1 "(TARGET_POWERPC64) && ( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()) && ( 1)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed")
  (-1 "reload_completed && int_reg_operand (operands[0], PTImode)")
  (-1 "(TARGET_P9_VECTOR) && ( 1)")
  (-1 "(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && (TARGET_POWERPC64)")
  (-1 "register_operand (operands[0], CCUNSmode)
   || register_operand (operands[1], CCUNSmode)")
  (-1 "gpc_reg_operand (operands[0], SImode)
   || gpc_reg_operand (operands[1], SImode)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && ( 1)")
  (-1 "(DEFAULT_ABI == ABI_AIX) && (TARGET_64BIT)")
  (-1 "!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)")
  (-1 "TARGET_XSCVDPSPN")
  (-1 "(VECTOR_MEM_VSX_P (TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0")
  (-1 "(!HONOR_SIGNED_ZEROS (SFmode) && !VECTOR_UNIT_ALTIVEC_P (SFmode)) && (TARGET_HARD_FLOAT)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))")
  (-1 "(SImode == Pmode) && ( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && ( reload_completed)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && ( 1)")
  (-1 "VECTOR_MEM_VSX_P (TImode)")
  (-1 "(TARGET_CMPB && TARGET_POPCNTB) && (TARGET_POWERPC64)")
  (-1 "((TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && (TARGET_64BIT)) && ( reload_completed)")
  (-1 "TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (TImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))")
  (-1 "TARGET_PCREL")
  (-1 "VECTOR_MEM_VSX_P (V1TImode)")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && ((((TARGET_64BIT) && (TARGET_POWERPC64)) && (TARGET_POWERPC64)) && (TARGET_POWERPC64))")
  (-1 "(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_64BIT")
  (-1 "(((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT && !TARGET_P9_VECTOR")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID) && ( 1)")
  (-1 "((FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && (TARGET_LONG_DOUBLE_128)) && ( reload_completed)")
  (-1 "(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && (TARGET_32BIT)")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(TARGET_POWERPC64 && TARGET_POWER10) && ( reload_completed)")
  (-1 "(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && ( reload_completed)")
  (-1 "(DEFAULT_ABI == ABI_DARWIN) && (TARGET_64BIT)")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (V2DFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode))")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)")
  (-1 "TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128")
  (-1 "(DEFAULT_ABI == ABI_V4 && flag_pic == 1)
   || (TARGET_TOC && TARGET_MINIMAL_TOC)
   || (DEFAULT_ABI == ABI_DARWIN && flag_pic)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FPRND
   && flag_unsafe_math_optimizations && !flag_trapping_math && TARGET_FRIZ")
  (0 "(TARGET_XCOFF && HAVE_AS_TLS) && (TARGET_64BIT)")
  (-1 "(TARGET_POPCNTD) && (TARGET_POWERPC64)")
  (-1 "!TARGET_POWERPC64 && TARGET_DIRECT_MOVE")
  (-1 "TARGET_P9_VECTOR && !reload_completed")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && ((((((TARGET_POWERPC64) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "INTVAL (operands[2]) == 32")
  (-1 "TARGET_P9_VECTOR && TARGET_64BIT")
  (-1 "TARGET_HARD_FLOAT
   && ((TARGET_PPC_GFXOPT
        && !HONOR_NANS (DFmode)
        && !HONOR_SIGNED_ZEROS (DFmode))
       || TARGET_CMPB
       || VECTOR_UNIT_VSX_P (DFmode))")
  (0 "(TARGET_MACHO && flag_pic) && (TARGET_64BIT)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed")
  (-1 "(TARGET_ALTIVEC) && (((FLOAT128_VECTOR_P (TFmode)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCFIDS) && ( reload_completed)")
  (-1 "(TARGET_ALTIVEC) && ((((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (FLOAT128_VECTOR_P (TFmode)))")
  (-1 "((TARGET_POWER10 && TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))) && ( 1)")
  (-1 "((TARGET_LONG_DOUBLE_128 && TARGET_VSX && FLOAT128_IBM_P (TFmode)) && (FLOAT128_IBM_P (TFmode))) && ( reload_completed)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && (TARGET_64BIT)")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(FLOAT128_IEEE_P (KFmode)
   || (FLOAT128_IBM_P (KFmode) && TARGET_HARD_FLOAT)) && (TARGET_FLOAT128_TYPE)")
  (-1 "((VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)) && ( reload_completed)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFID")
  (-1 "(!HONOR_SIGNED_ZEROS (V2DFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode))")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && (TARGET_64BIT)")
  (-1 "(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed")
  (-1 "(HAVE_AS_TLS) && (TARGET_32BIT)")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (TDmode)) && (TARGET_HARD_FLOAT)")
  (-1 "(FLOAT128_2REG_P (TDmode)) && (TARGET_HARD_FLOAT)")
  (-1 "(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_64BIT)")
  (-1 "(TARGET_FLOAT128_TYPE) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(TARGET_POWER10 && TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))")
  (0 "TARGET_MACHO && TARGET_64BIT")
  (-1 "TARGET_SYNC_TI && quad_int_reg_operand (operands[2], PTImode)")
  (-1 "(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (FLOAT128_2REG_P (TFmode))")
  (-1 "((VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && ( reload_completed)")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (KFmode))) && ( 1)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(!TARGET_XL_COMPAT && FLOAT128_IBM_P (IFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))")
  (-1 "((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "RS6000_RECIP_HAVE_RE_P (SFmode)")
  (-1 "((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (TFmode)) && (TARGET_LONG_DOUBLE_128)")
  (-1 "TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "TARGET_MODULO")
  (-1 "TARGET_MULHW")
  (-1 "((TARGET_XL_COMPAT && FLOAT128_IBM_P (IFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && ((FLOAT128_IBM_P (IFmode)) && (TARGET_POWERPC64))) && ( reload_completed)")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && ((((TARGET_32BIT) && (TARGET_P8_VECTOR)) && (TARGET_P8_VECTOR)) && (TARGET_P8_VECTOR))")
  (-1 "TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)")
  (-1 "TARGET_SYNC_HI_QI")
  (-1 "TARGET_EXTSWSLI")
  (-1 "((rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])")
  (-1 "(!flag_finite_math_only) && ( 1)")
  (-1 "((TARGET_P10_FUSION)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(!HONOR_SIGNED_ZEROS (DFmode)) && (TARGET_HARD_FLOAT || VECTOR_UNIT_VSX_P (DFmode))")
  (-1 "((TARGET_P10_FUSION)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))")
  (-1 "TARGET_VADDUQM")
  (-1 "TARGET_FLOAT128_TYPE")
  (-1 "(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode)")
  (-1 "RS6000_RECIP_HAVE_RE_P (V2DFmode)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V1TImode)) && (TARGET_ALTIVEC)")
  (-1 "(FLOAT128_IBM_P (TFmode) && !TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && (TARGET_HARD_FLOAT)")
  (-1 "((FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && (TARGET_32BIT)")
  (-1 "!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))")
  (-1 "(TARGET_P9_VECTOR) && ( reload_completed && vsx_register_operand (operands[1], SFmode))")
  (-1 "((TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))) && ( reload_completed)")
  (-1 "! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))")
  (-1 "((VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && ( 1)")
  (-1 "TARGET_POWER10 && rs6000_rop_protect")
  (-1 "((TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && (TARGET_LONG_DOUBLE_128)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))) && ( reload_completed
   && register_operand (operands[0], DImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))")
  (-1 "((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_IBM_P (IFmode))")
  (-1 "!TARGET_POWERPC64")
  (-1 "(VECTOR_MEM_ALTIVEC_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && (TARGET_ALTIVEC)")
  (-1 "TARGET_POWERPC64
   && num_insns_constant (operands[1], DImode) > 1
   && !IN_RANGE (INTVAL (operands[1]), -0x80000000, 0xffffffff)
   && rs6000_is_valid_and_mask (operands[1], DImode)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed")
  (-1 "(TARGET_POPCNTB) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (TARGET_64BIT)")
  (-1 "(rs6000_pcrel_p ()) && (TARGET_64BIT)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_ALTIVEC) && (((FLOAT128_VECTOR_P (KFmode)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (0 "(TARGET_XCOFF && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_32BIT)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "RS6000_RECIP_HAVE_RSQRTE_P (DFmode)")
  (-1 "TARGET_ELF && !TARGET_64BIT && !flag_pic")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()")
  (-1 "(HAVE_AS_TLS && TARGET_ELF) && (TARGET_64BIT)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && ( 1)")
  (0 "(TARGET_XCOFF && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_64BIT)")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && (TARGET_ALTIVEC)")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR")
  (-1 "TARGET_P9_MISC")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (SFmode)) && (TARGET_HARD_FLOAT)")
  (-1 "(((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (TFmode)) && (TARGET_LONG_DOUBLE_128)) && ( reload_completed)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && ( 1)")
  (-1 "((TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && (TARGET_LONG_DOUBLE_128)) && ( reload_completed)")
  (-1 "((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(!flag_finite_math_only) && (TARGET_POWERPC64)")
  (-1 "VECTOR_UNIT_ALTIVEC_P (V8HImode)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(VECTOR_UNIT_VSX_P (V2DFmode)) && ( 1)")
  (-1 "(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && (TARGET_POWERPC64)")
  (-1 "VECTOR_UNIT_ALTIVEC_P (V4SImode)")
  (-1 "! TARGET_POWERPC64 && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCTIWUZ && TARGET_STFIWX")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && ( reload_completed)")
  (-1 "(V8HImode == TImode || V8HImode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "TARGET_POPCNTB || TARGET_POPCNTD")
  (-1 "(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && ( 1)")
  (-1 "(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_32BIT)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed")
  (0 "((FLOAT128_2REG_P (IFmode) && TARGET_SOFT_FLOAT) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "TARGET_POWERPC64 && TARGET_POWER10")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && ( 1)")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && (TARGET_ALTIVEC)")
  (-1 "TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !(TARGET_P8_VECTOR && TARGET_DIRECT_MOVE)")
  (-1 "TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))")
  (-1 "TARGET_HTM")
  (-1 "VECTOR_UNIT_VSX_P (DFmode)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "FLOAT128_IEEE_P (TFmode)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN")
  (-1 "((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)) && ( reload_completed && cc_reg_not_cr0_operand (operands[5], CCmode))")
  (-1 "((TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && (TARGET_32BIT)) && ( reload_completed)")
  (-1 "TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)")
  (-1 "(V4SImode == TImode || V4SImode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_P9_MISC) && (TARGET_POWERPC64)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)")
  (-1 "VECTOR_MEM_ALTIVEC_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))")
  (-1 "(V2DFmode == TImode || V2DFmode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))")
  (-1 "(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS) && ( reload_completed)")
  (-1 "(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && (TARGET_32BIT)")
  (-1 "!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && (TARGET_ALTIVEC)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V2DImode)) && (TARGET_ALTIVEC)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFIDUS")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], SImode)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed")
  (-1 "TARGET_POWERPC64 && TARGET_DIRECT_MOVE")
  (-1 "TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))")
  (-1 "(TARGET_ALTIVEC) && (((FLOAT128_VECTOR_P (TFmode)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))")
  (-1 "rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)")
  (-1 "(!rs6000_speculate_indirect_jumps) && (TARGET_64BIT)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)")
  (-1 "VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "(TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))")
  (-1 "((FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && (TARGET_LONG_DOUBLE_128)) && ( reload_completed)")
  (0 "(FLOAT128_2REG_P (IFmode) && TARGET_SOFT_FLOAT) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))) && ( reload_completed)")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode) && VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode)")
  (-1 "((HAVE_AS_TLS && TARGET_ELF) && (TARGET_64BIT)) && ( TARGET_CMODEL != CMODEL_SMALL)")
  (-1 "((TARGET_P10_FUSION)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(!TARGET_FLOAT128_HW && FLOAT128_IEEE_P (TFmode)) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "((TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))) && ( 1)")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))")
  (-1 "(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)) && ( reload_completed && REG_P (operands[1]) && REGNO (operands[0]) == REGNO (operands[1]))")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()) && ( 1)")
  (-1 "(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)")
  (-1 "rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "((TARGET_LONG_DOUBLE_128 && TARGET_VSX && FLOAT128_IBM_P (IFmode)) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "TARGET_PCREL_OPT && TARGET_POWERPC64")
  (-1 "TARGET_MADDLD && TARGET_POWERPC64")
  (-1 "(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && ((((((TARGET_POWERPC64) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "VECTOR_MEM_VSX_P (V1TImode) && !BYTES_BIG_ENDIAN")
  (-1 "TARGET_FRE")
  (-1 "TARGET_HARD_FLOAT || VECTOR_UNIT_VSX_P (DFmode)")
  (-1 "(TARGET_XL_COMPAT && FLOAT128_IBM_P (IFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && ((FLOAT128_IBM_P (IFmode)) && (TARGET_POWERPC64))")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN")
  (-1 "(TARGET_ELF && HAVE_AS_TLS) && (TARGET_64BIT)")
  (-1 "TARGET_VSX")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "((TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_2REG_P (IFmode))) && ( reload_completed)")
  (-1 "(VECTOR_MEM_VSX_P (V4SFmode)) && (TARGET_64BIT)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "TARGET_HARD_FLOAT
   && ((TARGET_FCFIDUS && TARGET_LFIWZX)
       || (TARGET_FCFID
	   && (TARGET_POWERPC64 || flag_unsafe_math_optimizations)))")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))")
  (-1 "((VECTOR_MEM_VSX_P (V4SFmode)) && (TARGET_64BIT)) && ( reload_completed)")
  (-1 "(((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && (TARGET_POWERPC64)) && ( reload_completed)")
  (-1 "((INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && (TARGET_32BIT)")
  (-1 "(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && ( 1)")
  (-1 "(reload_completed
   && (int_reg_operand (operands[0], KFmode)
       || int_reg_operand (operands[1], KFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], KFmode)
           && !vsx_register_operand (operands[1], KFmode)))) && (FLOAT128_VECTOR_P (KFmode))")
  (1 "1")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (0 "((FLOAT128_2REG_P (TDmode) && TARGET_SOFT_FLOAT) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "(TARGET_FLOAT128_TYPE) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_NONE_P (PTImode)
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode)))")
  (-1 "TARGET_LONG_DOUBLE_128")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (V4SFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode))")
  (-1 "TARGET_POWER10 && TARGET_POWERPC64")
  (-1 "(TARGET_ALTIVEC) && (((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "(TARGET_ALTIVEC && reload_completed) && (TARGET_32BIT)")
  (-1 "((TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && (TARGET_64BIT)")
  (-1 "(!TARGET_VSX && TARGET_MINMAX) && ( 1)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)")
  (-1 "((TARGET_ALTIVEC && reload_completed) && (TARGET_32BIT)) && ( reload_completed)")
  (-1 "TARGET_POWER10 && TARGET_64BIT")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed")
  (-1 "((TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "(!TARGET_XL_COMPAT && FLOAT128_IBM_P (TFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))")
  (0 "(TARGET_MACHO && flag_pic) && ( reload_completed)")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 0)")
  (-1 "TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))")
  (-1 "((TARGET_POWER10 && TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))) && ( 1)")
  (-1 "(TARGET_PLTSEQ) && (TARGET_32BIT)")
  (-1 "(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && ( 1)")
  (-1 "(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && (TARGET_32BIT)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)")
  (-1 "TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32")
  (-1 "(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_ALTIVEC_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && TARGET_ALLOW_MOVMISALIGN")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode)
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 0 : 1)")
  (-1 "(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && (TARGET_ALTIVEC)")
  (-1 "(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))) && ( 1)")
  (-1 "(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && (FLOAT128_IBM_P (IFmode))")
  (-1 "VECTOR_MEM_ALTIVEC_P (V4SFmode)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_P9_VECTOR && TARGET_POWERPC64")
  (-1 "TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)")
  (-1 "(TARGET_ALTIVEC) && (((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT)) && (TARGET_32BIT))")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))")
  (-1 "TARGET_CMPB")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()")
  (-1 "(!(DImode == SImode && TARGET_POWERPC64)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()")
  (-1 "(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (TARGET_32BIT)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_FCFID) && ( reload_completed)")
  (-1 "((!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_64BIT)) && ( 1)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB")
  (-1 "((TARGET_XL_COMPAT && FLOAT128_IBM_P (TFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && ((FLOAT128_IBM_P (TFmode)) && (TARGET_POWERPC64))) && ( reload_completed)")
  (-1 "(TARGET_POWER10 && TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (TFmode)) && (TARGET_LONG_DOUBLE_128)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V4SImode)
       || int_reg_operand (operands[1], V4SImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SImode)
           && !vsx_register_operand (operands[1], V4SImode)))")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && (TARGET_64BIT)")
  (-1 "(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && (TARGET_64BIT)")
  (-1 "TARGET_CMPB && (BYTES_BIG_ENDIAN || TARGET_LDBRX)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])")
  (-1 "(TARGET_POWERPC64 && TARGET_DIRECT_MOVE && FLOAT128_2REG_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode)
   && VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode)")
  (-1 "(TARGET_ALTIVEC) && ((((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (FLOAT128_VECTOR_P (KFmode)))")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (TARGET_LONG_DOUBLE_128)")
  (-1 "(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))) && ( reload_completed)")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode) && VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)")
  (-1 "TARGET_NO_SF_SUBREG")
  (-1 "(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_64BIT)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_P9_MINMAX) && ( 1)")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode)")
  (-1 "((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && (TARGET_32BIT)")
  (-1 "((!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && (TARGET_POWERPC64)")
  (-1 "((TARGET_XL_COMPAT && FLOAT128_IBM_P (TFmode)
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))) && ( reload_completed)")
  (-1 "!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V4SFmode)
       || int_reg_operand (operands[1], V4SFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SFmode)
           && !vsx_register_operand (operands[1], V4SFmode)))")
  (-1 "!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))")
  (-1 "(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)")
  (-1 "(TARGET_NO_SF_SUBREG) && ( 1)")
  (-1 "(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))")
  (-1 "(!HONOR_SIGNED_ZEROS (KFmode) && !VECTOR_UNIT_ALTIVEC_P (KFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode))")
  (-1 "(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128 && FLOAT128_IBM_P (TFmode)) && (FLOAT128_IBM_P (TFmode))")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWAX")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "(SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)")
  (-1 "!flag_finite_math_only")
  (-1 "BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)")
  (-1 "TARGET_PCREL_OPT")
  (-1 "((INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_32BIT)")
  (-1 "(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && ( 1)")
  (-1 "(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE && TARGET_POWERPC64) && ( reload_completed)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(((TARGET_P10_FUSION)) && (TARGET_POWERPC64)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))")
  (-1 "(HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR")
  (0 "(TARGET_MACHO && flag_pic) && (TARGET_32BIT)")
  (-1 "!TARGET_VSX && TARGET_MINMAX")
  (-1 "(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && ( reload_completed)")
  (-1 "(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_32BIT)")
  (-1 "((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "INTVAL (operands[2]) == 16")
  (-1 "((TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && (TARGET_32BIT)) && ( reload_completed)")
  (-1 "((HAVE_AS_TLS) && (TARGET_32BIT)) && ( TARGET_CMODEL != CMODEL_SMALL)")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "(TARGET_ISEL) && (TARGET_POWERPC64)")
  (-1 "! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))")
  (-1 "VECTOR_MEM_VSX_P (V2DFmode)")
  (-1 "(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_32BIT")
  (-1 "TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))")
  (-1 "(TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (FLOAT128_2REG_P (IFmode))")
  (-1 "(TARGET_ALTIVEC) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(TARGET_DIRECT_MOVE) && ( reload_completed && int_reg_operand (operands[0], QImode))")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (KFmode))) && ( 1)")
  (-1 "reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && (TARGET_FLOAT128_HW)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed")
  (-1 "TARGET_P8_VECTOR && !TARGET_P9_VECTOR && reload_completed")
  (-1 "TARGET_HARD_FLOAT
   && VECTOR_UNIT_VSX_P (V2DFmode) && flag_unsafe_math_optimizations
   && !flag_trapping_math && TARGET_FRIZ")
  (-1 "TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)")
  (-1 "TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT)")
  (-1 "!WORDS_BIG_ENDIAN && !TARGET_POWERPC64")
  (-1 "TARGET_HARD_FLOAT && TARGET_FPRND")
  (-1 "TARGET_HARD_FLOAT
   && TARGET_FPRND
   && flag_unsafe_math_optimizations")
  (-1 "RS6000_RECIP_HAVE_RE_P (V4SFmode)")
  (-1 "TARGET_VSX && TARGET_HARD_FLOAT")
  (-1 "(TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT)")
  (-1 "RS6000_RECIP_HAVE_RSQRTE_P (SFmode)")
  (-1 "(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && (TARGET_64BIT)")
  (-1 "TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)")
  (-1 "(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(FLOAT128_2REG_P (TFmode)) && (TARGET_LONG_DOUBLE_128)")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "(TARGET_POWERPC64) && (1)")
  (0 "(TARGET_XCOFF && HAVE_AS_TLS) && (TARGET_32BIT)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "TARGET_ALTIVEC")
  (-1 "(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && (FLOAT128_2REG_P (IFmode))")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_DIRECT_MOVE) && ( reload_completed && int_reg_operand (operands[0], HImode))")
  (-1 "TARGET_ISEL")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V2DFmode)
       || int_reg_operand (operands[1], V2DFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DFmode)
           && !vsx_register_operand (operands[1], V2DFmode)))")
  (-1 "(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "TARGET_POWERPC64 && !TARGET_P9_VECTOR && reload_completed")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64")
  (-1 "((TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))) && ( 1)")
  (-1 "((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && (TARGET_64BIT)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)")
  (-1 "TARGET_HARD_FLOAT
   && ((TARGET_PPC_GFXOPT
        && !HONOR_NANS (SFmode)
        && !HONOR_SIGNED_ZEROS (SFmode))
       || TARGET_CMPB
       || VECTOR_UNIT_VSX_P (SFmode))")
  (-1 "(TARGET_PLTSEQ) && (TARGET_64BIT)")
  (-1 "VECTOR_MEM_VSX_P (V4SImode) && TARGET_P9_VECTOR && TARGET_POWERPC64")
  (-1 "(HAVE_AS_TLS && TARGET_ELF) && (TARGET_32BIT)")
  (-1 "(TARGET_DIRECT_MOVE_64BIT && reload_completed) && (TARGET_POWERPC64)")
  (-1 "VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN")
  (-1 "TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))")
  (-1 "(V4SFmode == TImode || V4SFmode == PTImode || TARGET_P8_VECTOR) && (TARGET_ALTIVEC)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(SImode == Pmode) && (TARGET_32BIT)")
  (-1 "!TARGET_POWERPC64 && reload_completed")
  (-1 "TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL")
  (-1 "TARGET_HARD_FLOAT")
  (-1 "((DImode == Pmode) && (TARGET_POWERPC64)) && ( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))")
  (-1 "TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))")
  (-1 "TARGET_FRES")
  (-1 "!rs6000_is_valid_and_mask (operands[2], SImode)")
  (-1 "(!HONOR_SIGNED_ZEROS (V2DFmode) && !VECTOR_UNIT_ALTIVEC_P (V2DFmode)) && (VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode))")
  (-1 "VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)")
  (-1 "((INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && (TARGET_ALTIVEC)")
  (-1 "VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()")
  (-1 "TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)")
  (-1 "(FLOAT128_IBM_P (TFmode) && TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))")
  (-1 "(TARGET_ALTIVEC) && (((((FLOAT128_VECTOR_P (TFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (TARGET_64BIT))")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (TFmode))) && ( 1)")
  (0 "TARGET_MACHO && !TARGET_64BIT")
  (-1 "(VECTOR_MEM_VSX_P (KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "TARGET_P8_FUSION")
  (-1 "rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0")
  (-1 "VECTOR_UNIT_ALTIVEC_P (V16QImode)")
  (-1 "(TARGET_POWER10 && TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (TFmode))")
  (-1 "(TARGET_POPCNTD) && (TARGET_64BIT)")
  (-1 "((DImode == Pmode) && (TARGET_64BIT)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)")
  (-1 "REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))")
  (-1 "(FLOAT128_2REG_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(rs6000_pcrel_p ()) && (TARGET_32BIT)")
  (-1 "TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))")
  (-1 "(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)) && ( 1)")
  (-1 "(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && (TARGET_POWERPC64)")
  (-1 "TARGET_HARD_FLOAT && TARGET_FCFIDU")
  (-1 "!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2")
  (-1 "((VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && (TARGET_FLOAT128_HW)) && ( reload_completed)")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "(VECTOR_MEM_VSX_P (V4SFmode)) && (TARGET_32BIT)")
  (-1 "((TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && (TARGET_HARD_FLOAT)) && ( reload_completed)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && (FLOAT128_VECTOR_P (TFmode))")
  (-1 "(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()) && ( 1)")
  (-1 "gpc_reg_operand (operands[0], QImode)
   || gpc_reg_operand (operands[1], QImode)")
  (-1 "(reload_completed && int_reg_operand (operands[0], V4SImode)) && (TARGET_ALTIVEC)")
  (-1 "VECTOR_UNIT_VSX_P (V4SFmode)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW
   && FLOAT128_IEEE_P (KFmode)) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && ( reload_completed)")
  (-1 "reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])")
  (-1 "(DImode == Pmode) && (TARGET_64BIT)")
  (-1 "((FLOAT128_IBM_P (TFmode) && !TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (TFmode))) && ( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))")
  (-1 "(!rs6000_is_valid_and_mask (operands[2], DImode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (TARGET_FLOAT128_TYPE)")
  (-1 "((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)) && ( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "!BYTES_BIG_ENDIAN && TARGET_VSX")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode)")
  (-1 "TARGET_PCREL_OPT
   && (TARGET_POWERPC64 || vsx_register_operand (operands[1], DFmode))")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "((TARGET_ALTIVEC && reload_completed) && (TARGET_64BIT)) && ( reload_completed)")
  (-1 "TARGET_MADDLD")
  (-1 "(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT")
  (-1 "((!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128 && FLOAT128_IBM_P (TFmode)) && (FLOAT128_IBM_P (TFmode))) && ( reload_completed)")
  (-1 "reload_completed
   && (int_reg_operand (operands[0], V1TImode)
       || int_reg_operand (operands[1], V1TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V1TImode)
           && !vsx_register_operand (operands[1], V1TImode)))")
  (-1 "(!TARGET_POWER10) && (TARGET_POWERPC64)")
  (-1 "(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && (FLOAT128_VECTOR_P (KFmode))")
  (-1 "(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128 && FLOAT128_IBM_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "TARGET_SYNC_TI")
  (-1 "(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && (FLOAT128_IEEE_P (KFmode))")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && TARGET_P9_VECTOR && TARGET_POWERPC64")
  (-1 "((!TARGET_POWERPC64 || !TARGET_DIRECT_MOVE) && FLOAT128_2REG_P (TDmode)) && (TARGET_HARD_FLOAT)")
  (-1 "((TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && (FLOAT128_VECTOR_P (TFmode))) && ( reload_completed)")
  (-1 "TARGET_DLMZB && WORDS_BIG_ENDIAN && !optimize_size")
  (-1 "FLOAT128_IBM_P (IFmode)")
  (-1 "DEFAULT_ABI == ABI_V4 && flag_pic == 1 && TARGET_32BIT")
  (-1 "(TARGET_HARD_FLOAT && FLOAT128_IBM_P (IFmode)) && (FLOAT128_IBM_P (IFmode))")
  (-1 "TARGET_DLMZB")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode)")
  (-1 "(TARGET_ALTIVEC) && ((((FLOAT128_VECTOR_P (KFmode)) && (TARGET_64BIT)) && (TARGET_64BIT)) && (FLOAT128_VECTOR_P (KFmode)))")
  (-1 "((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_32BIT)")
  (-1 "TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))")
  (-1 "((TARGET_P10_FUSION)) && (TARGET_POWERPC64)")
  (-1 "(FLOAT128_IBM_P (IFmode) && TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && (FLOAT128_IBM_P (IFmode))")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()")
  (-1 "((INTVAL (operands[2]) & CALL_LONG) == 0) && (TARGET_64BIT)")
  (-1 "((!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "(DEFAULT_ABI == ABI_ELFv2) && (TARGET_32BIT)")
  (-1 "((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && (TARGET_POWERPC64)")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && (TARGET_64BIT)")
  (-1 "(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64) && ( reload_completed)")
  (-1 "VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))")
  (-1 "(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && (TARGET_64BIT)")
  (-1 "(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))) && ( reload_completed
   && vsx_reg_sfsubreg_ok (operands[0], SFmode)
   && int_reg_operand_not_pseudo (operands[1], SImode))")
  (-1 "((TARGET_P10_FUSION)) && ( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))")
  (-1 "VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR")
  (-1 "TARGET_PCREL_OPT
   && reg_or_subregno (operands[0]) != reg_or_subregno (operands[3])")
  (-1 "(TARGET_P9_VECTOR && reload_completed) && (TARGET_POWERPC64)")
  (-1 "(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && ( 1)")
  (-1 "(gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT")
  (-1 "((!TARGET_ISEL) && (TARGET_POWERPC64)) && ( 1)")
  (-1 "TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (SFmode))")
  (-1 "(TARGET_HARD_FLOAT
   && (!FLOAT128_IEEE_P (TFmode)
       || (TARGET_POWERPC64 && TARGET_DIRECT_MOVE))) && (TARGET_LONG_DOUBLE_128)")
  (-1 "(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && (TARGET_ALTIVEC)")
  (-1 "(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && ( 1)")
  (-1 "((TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && (TARGET_64BIT)) && ( reload_completed)")
  (-1 "((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && ( reload_completed)")
  (-1 "(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))) && ( reload_completed
   && int_reg_operand (operands[0], SImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))")
  (-1 "(TARGET_POPCNTB || TARGET_POPCNTD) && (TARGET_POWERPC64)")
  (-1 "(!VECTOR_UNIT_ALTIVEC_P (KFmode)) && (TARGET_FLOAT128_HW && FLOAT128_IEEE_P (KFmode))")
  (-1 "(HAVE_AS_PLTSEQ && TARGET_ELF
   && rs6000_pcrel_p ()) && (TARGET_32BIT)")
  (-1 "TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])")
  (-1 "RS6000_RECIP_HAVE_RSQRTE_P (V2DFmode)")
  (-1 "(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && ( reload_completed)")
  (-1 "!WORDS_BIG_ENDIAN && TARGET_POWERPC64")
  (-1 "((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && (TARGET_ALTIVEC)")
  (-1 "(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && (TARGET_64BIT)")
  (-1 "((FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && (FLOAT128_IBM_P (IFmode))) && ( reload_completed)")
  (-1 "TARGET_POWERPC64 && INTVAL (operands[2]) == 32")
  (-1 "((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && (TARGET_32BIT)")
])
